//---------------------------------------------------------------------------
//pomocn knihovna
//obsahuje funkce potebn pro tvorbu prostorovho modelu ternu
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------

#ifndef GeometrieH
#define GeometrieH
#include <math.h>
//---------------------------------------------------------------------------
//tda definujc bod
class Tpoint
{
  public:
  int x,y;
  Tpoint(){;}
 
  //konstruktory
  Tpoint (TPoint l){x=l.x;y=l.y;}
  Tpoint (int a,int b){x=a;y=b;}
  //definice opertor
  Tpoint operator- (Tpoint b) {return Tpoint(x-b.x,y-b.y);}
  bool operator!= (Tpoint b)
  {
    if(x==b.x && y==b.y)return false;
    return true;

  }
  operator TPoint(){return TPoint(x,y);}
  TPoint operator+ (Tpoint b ){return TPoint(b.x+x,b.y+y);}

};
// tda definujc vektor
class TVector
{
  public:
  float x,y ;
  TVector(){}
  TVector(Tpoint l){x=l.x;y=l.y;}
  TVector(float a,float b){x=a;y=b;}
  friend TVector operator* (float k, TVector l){return TVector(l.x*k,l.y*k);}
  operator Tpoint(){return Tpoint(x,y);  }
};

//===================================================================
//funkce pevzata  z adresy http://www.geometryalgorithms.com  a upravena
//pomocn definice
#define SMALL_NUM  0.00000001 // anything that avoids division overflow
// dot product (3D) which allows vector operations in arguments
#define dot(u,v)   ((u).x * (v).x + (u).y * (v).y )
#define perp(u,v)  ((u).x * (v).y - (u).y * (v).x)  // perp product (2D)
#define norm(v)    sqrt(dot(v,v))  // norm = length of vector
#define d(u,v)     norm(u-v)       // distance = norm of difference

//---------------------------------------------------------------------------



#endif
